/**

   jZsh
   
**/
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>

#define CMD_BUFLEN 256
#define CMDARG_MAX 128
int main( int argc, char *argv[] )
{
static char cmd_line[CMD_BUFLEN+2] ;
int cmd_len ;
int pid,status ; 
int i,j,k ;
int arg_start ;
unsigned char *cmdarg_list[CMDARG_MAX] ;

 for( i=1 ; i<argc ; i++ ){
   if( argv[i][0]!='-' ) break ;
 }
 arg_start=i ;
 if( argc>1 ){
   if( (pid=fork())==0 ){
     execve( argv[arg_start], &argv[arg_start+1], NULL ) ;
     exit(100) ;
   }else if( pid == -1 ){
     exit(0) ;
   }else{
     int rc=wait(&status) ;
     if( rc==-1 ) exit(-1) ;
     exit(status) ;
   }
 }
   
 while( -1 ){
    printf("sh> ") ;
    fflush( stdout ) ;
    for( i=0 ; i<CMD_BUFLEN ; i++ ){
      cmd_line[i]='\0' ;
    }
    if( fgets( cmd_line, CMD_BUFLEN, stdin )==NULL ) break ;
    for( i=0 ; i<CMD_BUFLEN ; i++ ){
      if( cmd_line[i]=='\r' || cmd_line[i]=='\n'){
	break ;
      }
    }
    cmd_line[i]='\0' ;
    cmd_len=strlen(cmd_line) ;
    if( cmd_len==0 ) continue ;
    if( strcmp(cmd_line,"quit")==0 ||
        strcmp(cmd_line,"exit")==0 ) break ;
    fputs(cmd_line, stdout) ;
    fputs("\n",stdout) ;
    for( i=0,j=0,k=0 ; i<=cmd_len ; i++ ){
      if( cmd_line[i]=='\0' ){
	cmdarg_list[k++]=&cmd_line[j] ;
	break ;
      }
      if( cmd_line[i]==' ' ){
	cmdarg_list[k++]=&cmd_line[j] ;
	while( -1 ){
	  if( cmd_line[i]!=' ' ){
	    j=i ;
	    break ;
	  }else{
	    cmd_line[i]='\0' ;
	  }
	  i++ ;
	}
      }
    }
    
    if( (pid=fork())==0 ){
      execve( cmdarg_list[0], &cmdarg_list[1], NULL ) ;
    }else if( pid == -1 ){
      fputs("Command execute faild.\n",stdout) ;
      break ;
    }else{
      int rc=wait(&status) ;
      if( rc==-1 ){
	exit(-1) ;
      }
    }
 }
 exit(0) ;
}
     
